#ifndef _OSLFUNC_LEOJAVA_H
#define _OSLFUNC_LEOJAVA_H

#define zero(X)	(X<0?0:X)
#define ipow(a, b)	((int)pow(a, b))

#define loadPNG(file) oslLoadImageFilePNG(file, OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888)
#define wd(str) ({	if(!oslSyncFrame()){oslStartDrawing();	oslPrintf(str);	oslEndDrawing();}	oslEndFrame();	oslSyncFrame();})
#define wait() ({	oslReadKeys();	while(!osl_pad.pressed.cross){	oslReadKeys();	}	oslReadKeys();	})

#define DrawImageFrame(img, frame)                      ({ oslSetImageFrame(img, frame); oslDrawImage(img); })
#define DrawImageFrameXY(img, x, y, frame)  ({ oslSetImageFrame(img, frame);  oslDrawImageXY(img, x, y);})

OSL_IMAGE *loadSpritePNG(char *, int, int, int, int);
int getImageFrame(OSL_IMAGE *);
void DrawImageOffset(OSL_IMAGE *, int, int, int, int, int, int);
void wh(int);
void ws(char *);
int getRam(int m);

OSL_IMAGE *loadSpritePNG(char *filename, int location, int pixelFormat, int frameWidth, int frameHeight)          {
        OSL_IMAGE *img = oslLoadImageFile(filename, location, pixelFormat);
        if (img)
                oslSetImageFrameSize(img, frameWidth, frameHeight);
        return img;
}

int getImageFrame(OSL_IMAGE* img){
	int frame=0;
	u32 framesPerLine	= img->sizeX / img->frameSizeX;
	//u32 framesPerCol	= img->sizeY / img->frameSizeY;
	//u32 frames = framesPerLine * framesPerCol;
	
	int line = img->offsetY0 / img->frameSizeY;
	int col  = img->offsetX0 / img->frameSizeX;
	
	frame	= (line * framesPerLine) + col;
		
	return frame;
}

void DrawImageOffset(OSL_IMAGE* img, int X, int Y, int X0, int Y0, int width, int height){
	img->offsetX0	= X0;
	img->offsetY0	= Y0;
	img->offsetX1	= img->offsetX0 + width;
	img->offsetY1	= img->offsetY0 + height;
	img->stretchX	= width;
	img->stretchY	= height;
	oslDrawImageXY(img, X, Y);
}

void wh(int col){	
	int skip1=0;
	if(!skip1){
		oslStartDrawing();			oslClearScreen(col);			oslEndDrawing();
	}
	oslEndFrame();		skip1 = oslSyncFrame();
	wait();
}


void ws(char *str){
	int skip1=0;
	while(1){
		oslReadKeys();
		if(!skip1){
			oslStartDrawing();
			oslClearScreen(RGB(255, 0, 0));
			oslDrawString(10, 30, str);
			oslEndDrawing();
		}
		oslEndFrame();
		skip1 = oslSyncFrame();
//		if(osl_pad.held.cross) return;
		if(osl_pad.pressed.cross){	oslReadKeys(); return;	}
	}
}
void wi(int n){
	char *s=(char*)malloc(32);
	sprintf(s, "%i", n);
	int skip1=0;
	while(1){
		oslReadKeys();
		if(!skip1){
			oslStartDrawing();
			oslClearScreen(RGB(255, 0, 0));
			oslDrawString(10, 30, s);
			oslEndDrawing();
		}
		oslEndFrame();
		skip1 = oslSyncFrame();
//		if(osl_pad.held.cross) return;
		if(osl_pad.pressed.cross){	oslReadKeys(); return;	}
	}
}

int getRam(int m=0){
		OSL_MEMSTATUS ram;
		ram=oslGetRamStatus();
	if(m==0){
		char *str=NULL;
		str=(char*)malloc(32);
		sprintf(str, "%i", ram.maxAvailable);
		ws(str);
		free(str);
		str=NULL;
		oslReadKeys();
	}else if(m==2){
		char *str=NULL;
		int i=2;
		str=(char*)malloc(1);
		while(str!=NULL){
			free(str);
			str=NULL;
			str=(char*)malloc(i);//new char[i];
			i+=1000;
		}
		i-=1000;
		while(str!=NULL){
			free(str);
			str=NULL;
			str=(char*)malloc(i);//new char[i];
			i++;
		}
		return i;
	}
	return ram.maxAvailable;
}
#include <fstream>											///////////////////////////////////////////////////////////////////////////////////////////////////////////////
using namespace std;
void write(char *fn, char *s, int m=0){
	if(m==0){
		FILE *f=NULL;
		if(s!=NULL && fn!=NULL && (f=fopen(fn, "w+"))!=NULL){
			fprintf(f, s);
			fclose(f);
		}
	}else{
		ofstream out(fn);
		int i=0;
		while(i<(int)sizeof(s)){
			out.put(s[i]);
			i++;
		}
	}
	return;
}

char *read(char *fn){
	char *fbuf;
	FILE *f=fopen(fn, "r");
	int i=1;
	char t=0;
	if(f==NULL)	return NULL;
	fbuf=(char*)malloc(1);
	while((t=fgetc(f))!=EOF){
		fbuf=(char*)realloc(fbuf, i);
		*(fbuf+i-1)=t;
		i++;
	}
	fbuf=(char*)realloc(fbuf, i);
	*(fbuf+i-1)=0;
	fclose(f);
	return fbuf;
}


template <typename T>
void resize(T *&array, size_t old_size, size_t new_size)
{
	if(new_size<old_size){
		old_size=new_size;
	}
	T *tmp =new T[new_size];
	for(unsigned int i=0;i<old_size;i++){
		tmp[i]=array[i];
	}
	delete [] array;
	array = tmp;
}


template <typename T>
int sizeOfArray(T *ar){
	int s1=sizeof(ar);
	int s2=0;
	short a=0;
	T tmp;
	exception e;
	for(int i=0;a==0 && i<1000;i++){
		try{
			cout<<"\t"<<i<<endl;
			tmp=ar[i];
			ar[i]=tmp;
		}catch(e){
			cerr << "Error: "<<e.what()<<endl;
			a=1;
		}
	}
	return 2;
}

#endif

